﻿// Keep this lines for a best effort IntelliSense of Visual Studio 2017.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Controls\System\TcHmiControl\Source.d.ts" />

// Keep this lines for a best effort IntelliSense of Visual Studio 2013/2015.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery\jquery.js" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.js" />

(function (TcHmi) {

    var blockInterval;
    var secondCounter = 0;
    var elementToBlock;
    var maxNumberSeconds = 0;

    var BlockDesktopForDefinedTime = function (DesktopViewRoot, nTimeInSeconds) {

        // check for valid references
        if (!DesktopViewRoot)
            return;

        if (!nTimeInSeconds)
            return;

        // clear timer if already exists
        if (blockInterval) {
            clearInterval(blockInterval);
            blockInterval = null;
        }

        // reset second counter
        if (secondCounter !== 0) {
            secondCounter = 0;
        }

        // save references for scope outside function
        elementToBlock = DesktopViewRoot;
        maxNumberSeconds = nTimeInSeconds;

        // block interaction with the defined element
        DesktopViewRoot.setIsEnabled(false);

        // start timer with watch for every second
        blockInterval = setInterval(blockWatch, 1000);
    };

    // callback function for timer
    function blockWatch() {
        // count seconds
        secondCounter += 1;

        // maximum number of seconds reached
        if (secondCounter === maxNumberSeconds) {
            // reset enbaled state
            elementToBlock.setIsEnabled(true);

            // clear timer
            if (blockInterval) {
                clearInterval(blockInterval);
                blockInterval = null;
            }
        }
    }
    
    TcHmi.Functions.registerFunction('BlockDesktopForDefinedTime', BlockDesktopForDefinedTime);
})(TcHmi);